/**
 * purple-console
 * javascript component that prints logs in a DIV layer. It can be useful when dealing with special hardware like Smart TVs or Set-Top Boxes which do not allow debugging.
 * @version 1.2.7 - 2021-06-18
 * @link https://github.com/ajsoriar/purple-console
 * @author Andres J. Soria R. <ajsoriar@gmail.com>
 * @license MIT License, http://www.opensource.org/licenses/MIT
 */
!function(){var ajsrConsole=function(options,e){"use strict";function init(params){var consoleType=params.mode,consoleID="ajsrConsole",htmlString="";"TEXTAREA"==consoleType||"CANVAS"===consoleType||(htmlString='<div id="'+consoleID+'" style="position: absolute;bottom: 0;left: 0;width: 400px;height: 300px;background-color: #37006b;color: #ff8100;font-family: monospace;font-size: 11px;padding: 3px;z-index: 99998;overflow-x: hidden;overflow-y: auto;-moz-box-sizing: border-box;-webkit-box-sizing: border-box;box-sizing: border-box;border: 1px solid #ef3ffd;">The purple-console v'+defaults.version+' is waiting for logs...<br><div id="ajsrConsole-tools" style="visibility: '+(defaults.tools===!0?"":"hidden")+'; position: fixed;top: 0;left: 0;display: block;z-index: 99999;font-size: 11px;color: white;">'+tools.getToolsHtml()+"</div>"),createConsoleEl(htmlString),setPrintStrategy(3)}var defaults={opacity:!1,useColors:!1,autoRemoveOldDivs:null,printTime:!1,bgColor:"#37006b",borderColor:"#ef3ffd",textColor:"white",corner:null,maxObjLength:5,fontSize:11,tools:!1,version:"1.2.7",date:"2021-06-18"},el=null,printFunction=null,previousPrintAtemptTiemstamp=0,printAtemptTimeBoundary=500,printAtemptBuffer="",timer=null,tools={};tools.canvas={buttonSize:{width:18,height:18},list:[{name:"up",action:"ajsrConsole.move('UP')",label:"&#8593",position:{x:1,y:0}},{name:"down",action:"ajsrConsole.move('DOWN')",label:"&#8595",position:{x:0,y:0}},{name:"left",action:"ajsrConsole.move('LEFT')",label:"&#8592",position:{x:1,y:1}},{name:"right",action:"ajsrConsole.move('RIGHT')",label:"&#8594",position:{x:0,y:1}},{name:"cls",action:"ajsrConsole.cls()",label:"cls",position:{x:0,y:2}},{name:"autoheight",action:"ajsrConsole.autoHeight()",label:"h",position:{x:1,y:2}}]};var createConsoleEl=function(htmlString){var ct=document.createElement("div");ct.setAttribute("id","ajsrConsole-container"),ct.innerHTML=htmlString,document.body.appendChild(ct),el=ct.firstChild};tools.getToolButton=function(i){var str="";return str+='<div onclick="'+tools.canvas.list[i].action+'" style="position: absolute;',str+="right: "+tools.canvas.list[i].position.x*tools.canvas.buttonSize.width+"px;",str+="top: "+tools.canvas.list[i].position.y*tools.canvas.buttonSize.width+"px;",str+="cursor:pointer;",str+="background-color: rgba(0,0,0,0.4);",str+="background-position:"+i*tools.canvas.buttonSize.width+"px;",str+="width: "+tools.canvas.buttonSize.width+"px;height: "+tools.canvas.buttonSize.height+"px; background-image:",str+="box-sizing: border-box;",str+="-moz-box-sizing: border-box;",str+="-webkit-box-sizing: border-box;",str+="text-align: center;",str+="line-height:"+tools.canvas.buttonSize.height+"px;",str+="border: 1px solid #004c69;text-shadow: 0 1px 0 black;font-family: sans-serif;font-weight: bold;",str+='" on>'+tools.canvas.list[i].label+"</div>"},tools.getToolsHtml=function(){if(defaults.tools!==!1){for(var str="",lon=tools.canvas.list.length,i=0;lon>i;i++)str+=tools.getToolButton(i);return str}},tools.refreshPosition=function(){if(defaults.tools!==!1){var el_container=document.getElementById("ajsrConsole"),vo_container=el_container.getBoundingClientRect(),el_tools=document.getElementById("ajsrConsole-tools");el_tools.getBoundingClientRect();el_tools.style.top=vo_container.y+"px",el_tools.style.left=vo_container.x+vo_container.width+"px"}};var getTimeString=function(){var d=new Date,t=d.toLocaleTimeString();return t+" "},log=function(str,color,indentation){var t=getTimeString();defaults.printTime===!0&&(str=t+": "+str),write(str,color)},write=function(str,color){attachHTML(defaults.useColors===!0&&null!=color?'<span style="color:'+color+'">'+str+"</span><br>":str+"<br>")},error=function(str){str||(str="KO"),attachHTML('<span style="color:red">'+str+"</span><br>")},success=function(str){str||(str="OK"),attachHTML('<span style="color:limegreen">'+str+"</span><br>")},setPrintStrategy=function(num){switch(num){case 1:printFunction=directAttachHTML,success('Printing strategy was set to "direct"');break;case 2:printFunction=delayedAttachHtmlByTimestamp,success('Printing strategy was set to "delayed by timestamp"');break;case 3:printFunction=attachHtmlByTimeout,success('Printing strategy was set to "delayed by timeout"');break;default:error()}},attachHTML=function(str){printFunction(str)},directAttachHTML=function(str){el.innerHTML=printAtemptBuffer+str},delayedAttachHtmlByTimestamp=function(str){var currentPrintAtemptTiemstamp=Date.now();currentPrintAtemptTiemstamp>previousPrintAtemptTiemstamp+printAtemptTimeBoundary?(el.innerHTML=printAtemptBuffer+str,printAtemptBuffer="",refreshScroll()):printAtemptBuffer+=str},attachHtmlByTimeout=function(str){window.clearTimeout(timer),printAtemptBuffer+=str,timer=window.setTimeout(function(){delayedAttachHtmlByTimeout(str)},printAtemptTimeBoundary)},delayedAttachHtmlByTimeout=function(str){el.innerHTML+=printAtemptBuffer,printAtemptBuffer="",timer=null,refreshScroll()},refreshScroll=function(){el.scrollTop=el.scrollHeight},br=function(){attachHTML("<br>")},filterJSErrors=function(){window.onerror=function(message,url,lineNumber){message="JS ERROR: In line "+lineNumber+": "+message;try{this.log(message,"red")}catch(error){}return!1}},printObj=function(o,borderColor,backgroundColor){borderColor||(borderColor="gray"),backgroundColor||(backgroundColor="transparent");var MAX_LEN=defaults.maxObjLength;if(o!==Object(o))return void write("Not an object!","red");var p,str,k=[];for(p in o)Object.prototype.hasOwnProperty.call(o,p)&&k.push(p);var lon=k.length;if(lon>MAX_LEN)return void write("<b>Sorry, this object has more than "+MAX_LEN+" properties. </b>Please use 'setMaxObjLength()' to print bigger objets","red");str='<div style="padding:2px 5px;border:1px solid '+borderColor+"; background-color: "+backgroundColor+'">';for(var i=0;lon>i;i++)str+=JSON.stringify(k[i])+': <span style="color:yellow">'+JSON.stringify(o[k[i]])+"</span><br>";str+="</div>",write(str)},debugObj=function(p_1,p_2,p_3,p_4,p_5){"string"==typeof p_1?(p_3||(p_3="gray"),p_5||(p_5="white"),attachHTML('<span style="color: '+p_5+"; background-color: "+p_3+'; padding: 3px 3px 2px 3px;">'+arguments[0]+"</span><br>"),printObj(p_2,p_3,p_4)):printObj(p_1,p_2,p_3)},hide=function(){document.getElementById("ajsrConsole-container").setAttribute("style","display: none")},show=function(){document.getElementById("ajsrConsole-container").setAttribute("style","display: block")},defaultStart=function(){init({mode:"HTML"})};if(null!=document.body)defaultStart();else if(window.onload){var currentOnLoad=window.onload,newOnLoad=function(ev){currentOnLoad(ev),init(ev),defaultStart()};window.onload=newOnLoad}else window.onload=defaultStart;return{el:null,data:{startTime:null,laps:null},init:function(value){init({mode:"HTML"})},log:log,cls:function(){el.innerHTML=""},disableAutoBlocks:function(){},enableAutoBlocks:function(ms){},setAutoBlokTime:function(ms){},disableAutoScroll:function(){},enableAutoScroll:function(){},resetColors:function(){this.setBgColor(defaults.bgColor),this.setBorderColor(defaults.borderColor),this.setTextColor(defaults.textColor)},setLogAlias:function(str){window[str]=window.ajsrConsole.log,window[str].printObj=window.ajsrConsole.printObj,window[str].br=window.ajsrConsole.br},setConsoleAlias:function(str){window[str]=window.ajsrConsole},setBgColor:function(color){el.style.backgroundColor=color},setBorderColor:function(color){el.style.borderColor=color},setTextColor:function(color){el.style.color=color},move:function(str){var c=el;switch(str){case"UP":c.style.top="0",c.style.bottom="";break;case"DOWN":c.style.top="",c.style.bottom="0";break;case"LEFT":c.style.left="0",c.style.right="";break;case"RIGHT":c.style.left="",c.style.right="0"}tools.refreshPosition()},moveNext:function(){null===defaults.corner&&(defaults.corner=4),4===defaults.corner?this.move("UP"):3===defaults.corner?this.move("RIGHT"):2===defaults.corner?this.move("DOWN"):1===defaults.corner&&this.move("LEFT"),defaults.corner--,0===defaults.corner&&(defaults.corner=4)},autoHeight:function(){var c=el;"100%"===c.style.height?c.style.height="33%":"33%"===c.style.height?c.style.height="66%":c.style.height="100%",refreshScroll(),tools.refreshPosition()},setSize:function(w,h){var c=el;c.style.width=w+"px",c.style.height=h+"px",tools.refreshPosition()},toggleOpacity:function(){defaults.opacity?(el.style.backgroundColor="rgba(0, 0, 150, 1)",defaults.opacity=!1):(el.style.backgroundColor="rgba(0, 0, 150, 0.5)",defaults.opacity=!0)},useColors:function(useColors){useColors===!1?defaults.useColors=!1:defaults.useColors=!0},printTime:function(printTime){printTime===!1?defaults.printTime=!1:defaults.printTime=!0},setParams:function(){},startTime:function(){this.data.startTime=Date.now(),this.log(getTimeString()+"Time stats now!"),this.data.laps=[{label:"Time starts here!",timestamp:this.data.startTime,elapsed:0}]},setLap:function(label){this.data.startTime||this.startTime();var now=Date.now(),elapsed=now-this.data.startTime;this.log(getTimeString()+label+"; Seconds elapsed: "+elapsed/1e3+" s.");var obj={label:label,timestamp:now,elapsed:elapsed};return this.data.laps.push(obj),obj},printLaps:function(){var str=this.data.laps;return this.log(JSON.stringify(str)),str},filterJSErrors:filterJSErrors,printObj:printObj,obj:printObj,debugObj:debugObj,write:write,error:error,success:success,setMaxObjLength:function(num){defaults.maxObjLength=num,success("maxObjLength was set to "+num+"!")},br:br,setPrintStrategy:setPrintStrategy,hide:hide,show:show,fontSize:function(num){num||(num=defaults.fontSize),el.style.fontSize=num+"px"},showTools:function(){defaults.tools=!0,tools.refreshPosition(),document.getElementById("ajsrConsole-tools").style.visibility=""},hideTools:function(){document.getElementById("ajsrConsole-tools").style.visibility="hidden"},preset:function(){this.setLogAlias("debug"),this.setConsoleAlias("Cnsl"),this.setBgColor("rgba(0,0,150,1)"),this.setBorderColor("rgba(0,255,255,1)"),this.setTextColor("rgba(255,255,255,1)"),this.move("UP"),this.move("RIGHT"),this.useColors(),this.printTime(),this.setMaxObjLength(100),this.fontSize(11),this.autoHeight(),this.autoHeight(),this.autoHeight(),this.autoHeight()}}};window.ajsrConsole=ajsrConsole(),window.debugObj=window.ajsrConsole.debugObj}();